org.apache.commons.ssl

## Class Base64

- java.lang.Object
- - org.apache.commons.ssl.Base64

    public class Base64
    extends java.lang.Object

Provides Base64 encoding and decoding as defined by RFC 2045.

This class implements section 6.8. Base64 Content-Transfer-Encoding from RFC 2045 Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies by Freed and Borenstein.

The class can be parameterized in the following manner with various constructors:

- URL-safe mode: Default off.
- Line length: Default 76. Line length that aren't multiples of 4 will still essentially end up being multiples of 4 in the encoded data.
- Line separator: Default is CRLF ("\r\n")

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

Since:
  1.0
Version:
  $Id: Base64.java 155 2009-09-17 21:00:58Z julius $
Author:
  Apache Software Foundation
See Also:
  RFC 2045

### Field Summary

Fields
`private byte[]` `buffer` Buffer for streaming.
`(package private) static byte[]` `CHUNK_SEPARATOR` Chunk separator per RFC 2045 section 2.1.
`(package private) static int` `CHUNK_SIZE` Chunk size per RFC 2045 section 6.8.
`private int` `currentLinePos` Variable tracks how many characters have been written to the current line.
`private static byte[]` `DECODE_TABLE` This array is a lookup table that translates Unicode characters drawn from the "Base64 Alphabet" (as specified in Table 1 of RFC 2045) into their 6-bit positive integer equivalents.
`private int` `decodeSize` Convenience variable to help us determine when our buffer is going to run out of room and needs resizing.
`private static int` `DEFAULT_BUFFER_RESIZE_FACTOR`
`private static int` `DEFAULT_BUFFER_SIZE`
`private int` `encodeSize` Convenience variable to help us determine when our buffer is going to run out of room and needs resizing.
`private byte[]` `encodeTable` Encode table to use: either STANDARD or URL_SAFE.
`private boolean` `eof` Boolean flag to indicate the EOF has been reached.
`private int` `lineLength` Line length for encoding.
`private byte[]` `lineSeparator` Line separator for encoding.
`private static int` `MASK_6BITS` Mask used to extract 6 bits, used when encoding
`private static int` `MASK_8BITS` Mask used to extract 8 bits, used in decoding base64 bytes
`private int` `modulus` Writes to the buffer only occur after every 3 reads when encoding, an every 4 reads when decoding.
`private static byte` `PAD` Byte used to pad output.
`private int` `pos` Position where next character should be written in the buffer.
`private int` `readPos` Position where next character should be read from the buffer.
`private static byte[]` `STANDARD_ENCODE_TABLE` This array is a lookup table that translates 6-bit positive integer index values into their "Base64 Alphabet" equivalents as specified in Table 1 of RFC 2045.
`private static byte[]` `URL_SAFE_ENCODE_TABLE` This is a copy of the STANDARD_ENCODE_TABLE above, but with + and / changed to - and _ to make the encoded Base64 results more URL-SAFE.
`private int` `x` Place holder for the 3 bytes we're dealing with for our base64 logic.

### Constructor Summary

Constructors
Constructor and Description
`Base64()` Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.
`Base64(boolean urlSafe)` Creates a Base64 codec used for decoding (all modes) and encoding in the given URL-safe mode.
`Base64(int lineLength)` Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.
`Base64(int lineLength, byte[] lineSeparator)` Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.
`Base64(int lineLength, byte[] lineSeparator, boolean urlSafe)` Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.

### Method Summary

Methods
`(package private) int` `avail()` Returns the amount of buffered data available for reading.
`private static boolean` `containsBase64Byte(byte[] arrayOctet)` Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.
`byte[]` `decode(byte[] pArray)` Decodes a byte[] containing containing characters in the Base64 alphabet.
`(package private) void` `decode(byte[] in, int inPos, int inAvail)` Decodes all of the provided data, starting at inPos, for inAvail bytes.
`java.lang.Object` `decode(java.lang.Object pObject)` Decodes an Object using the base64 algorithm.
`byte[]` `decode(java.lang.String pArray)` Decodes a String containing containing characters in the Base64 alphabet.
`static byte[]` `decodeBase64(byte[] base64Data)` Decodes Base64 data into octets
`static byte[]` `decodeBase64(java.lang.String base64String)` Decodes a Base64 String into octets
`static java.math.BigInteger` `decodeInteger(byte[] pArray)` Decodes a byte64-encoded integer according to crypto standards such as W3C's XML-Signature
`(package private) static byte[]` `discardWhitespace(byte[] data)` Deprecated. This method is no longer needed
`byte[]` `encode(byte[] pArray)` Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.
`(package private) void` `encode(byte[] in, int inPos, int inAvail)` Encodes all of the provided data, starting at inPos, for inAvail bytes.
`java.lang.Object` `encode(java.lang.Object pObject)` Encodes an Object using the base64 algorithm.
`static byte[]` `encodeBase64(byte[] binaryData)` Encodes binary data using the base64 algorithm but does not chunk the output.
`static byte[]` `encodeBase64(byte[] binaryData, boolean isChunked)` Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
`static byte[]` `encodeBase64(byte[] binaryData, boolean isChunked, boolean urlSafe)` Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
`static byte[]` `encodeBase64(byte[] binaryData, boolean isChunked, boolean urlSafe, int maxResultSize)` Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
`static byte[]` `encodeBase64Chunked(byte[] binaryData)` Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks
`static java.lang.String` `encodeBase64String(byte[] binaryData)` Encodes binary data using the base64 algorithm into 76 character blocks separated by CRLF.
`static byte[]` `encodeBase64URLSafe(byte[] binaryData)` Encodes binary data using a URL-safe variation of the base64 algorithm but does not chunk the output.
`static java.lang.String` `encodeBase64URLSafeString(byte[] binaryData)` Encodes binary data using a URL-safe variation of the base64 algorithm but does not chunk the output.
`static byte[]` `encodeInteger(java.math.BigInteger bigInt)` Encodes to a byte64-encoded integer according to crypto standards such as W3C's XML-Signature
`java.lang.String` `encodeToString(byte[] pArray)` Encodes a byte[] containing binary data, into a String containing characters in the Base64 alphabet.
`private static long` `getEncodeLength(byte[] pArray, int chunkSize, byte[] chunkSeparator)` Pre-calculates the amount of space needed to base64-encode the supplied array.
`(package private) boolean` `hasData()` Returns true if this Base64 object has buffered data for reading.
`static boolean` `isArrayByteBase64(byte[] arrayOctet)` Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.
`static boolean` `isBase64(byte octet)` Returns whether or not the `octet` is in the base 64 alphabet.
`boolean` `isUrlSafe()` Returns our current encode mode.
`private static boolean` `isWhiteSpace(byte byteToCheck)` Checks if a byte value is whitespace or not.
`(package private) int` `readResults(byte[] b, int bPos, int bAvail)` Extracts buffered data into the provided byte[] array, starting at position bPos, up to a maximum of bAvail bytes.
`private void` `reset()` Resets this Base64 object to its initial newly constructed state.
`private void` `resizeBuffer()` Doubles our buffer.
`(package private) void` `setInitialBuffer(byte[] out, int outPos, int outAvail)` Sets the streaming buffer.
`(package private) static byte[]` `toIntegerBytes(java.math.BigInteger bigInt)` Returns a byte-array representation of a `BigInteger` without sign bit.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_BUFFER_RESIZE_FACTOR

    private static final int DEFAULT_BUFFER_RESIZE_FACTOR

See Also:
  Constant Field Values

#### DEFAULT_BUFFER_SIZE

    private static final int DEFAULT_BUFFER_SIZE

See Also:
  Constant Field Values

#### CHUNK_SIZE

    static final int CHUNK_SIZE

Chunk size per RFC 2045 section 6.8.

The 76 character limit does not count the trailing CRLF, but counts all other characters, including any equal signs.

See Also:
  RFC 2045 section 6.8, Constant Field Values

#### CHUNK_SEPARATOR

    static final byte[] CHUNK_SEPARATOR

Chunk separator per RFC 2045 section 2.1.

N.B. The next major release may break compatibility and make this field private.

See Also:
  RFC 2045 section 2.1

#### STANDARD_ENCODE_TABLE

    private static final byte[] STANDARD_ENCODE_TABLE

This array is a lookup table that translates 6-bit positive integer index values into their "Base64 Alphabet" equivalents as specified in Table 1 of RFC 2045. Thanks to "commons" project in ws.apache.org for this code. http://svn.apache.org/repos/asf/webservices/commons/trunk/modules/util/

#### URL_SAFE_ENCODE_TABLE

    private static final byte[] URL_SAFE_ENCODE_TABLE

This is a copy of the STANDARD_ENCODE_TABLE above, but with + and / changed to - and _ to make the encoded Base64 results more URL-SAFE. This table is only used when the Base64's mode is set to URL-SAFE.

#### PAD

    private static final byte PAD

Byte used to pad output.

See Also:
  Constant Field Values

#### DECODE_TABLE

    private static final byte[] DECODE_TABLE

This array is a lookup table that translates Unicode characters drawn from the "Base64 Alphabet" (as specified in Table 1 of RFC 2045) into their 6-bit positive integer equivalents. Characters that are not in the Base64 alphabet but fall within the bounds of the array are translated to -1. Note: '+' and '-' both decode to 62. '/' and '_' both decode to 63. This means decoder seamlessly handles both URL_SAFE and STANDARD base64. (The encoder, on the other hand, needs to know ahead of time what to emit). Thanks to "commons" project in ws.apache.org for this code. http://svn.apache.org/repos/asf/webservices/commons/trunk/modules/util/

#### MASK_6BITS

    private static final int MASK_6BITS

Mask used to extract 6 bits, used when encoding

See Also:
  Constant Field Values

#### MASK_8BITS

    private static final int MASK_8BITS

Mask used to extract 8 bits, used in decoding base64 bytes

See Also:
  Constant Field Values

#### encodeTable

    private final byte[] encodeTable

Encode table to use: either STANDARD or URL_SAFE. Note: the DECODE_TABLE above remains static because it is able to decode both STANDARD and URL_SAFE streams, but the encodeTable must be a member variable so we can switch between the two modes.

#### lineLength

    private final int lineLength

Line length for encoding. Not used when decoding. A value of zero or less implies no chunking of the base64 encoded data.

#### lineSeparator

    private final byte[] lineSeparator

Line separator for encoding. Not used when decoding. Only used if lineLength > 0.

#### decodeSize

    private final int decodeSize

Convenience variable to help us determine when our buffer is going to run out of room and needs resizing. `decodeSize = 3 + lineSeparator.length;`

#### encodeSize

    private final int encodeSize

Convenience variable to help us determine when our buffer is going to run out of room and needs resizing. `encodeSize = 4 + lineSeparator.length;`

#### buffer

    private byte[] buffer

Buffer for streaming.

#### pos

    private int pos

Position where next character should be written in the buffer.

#### readPos

    private int readPos

Position where next character should be read from the buffer.

#### currentLinePos

    private int currentLinePos

Variable tracks how many characters have been written to the current line. Only used when encoding. We use it to make sure each encoded line never goes beyond lineLength (if lineLength > 0).

#### modulus

    private int modulus

Writes to the buffer only occur after every 3 reads when encoding, an every 4 reads when decoding. This variable helps track that.

#### eof

    private boolean eof

Boolean flag to indicate the EOF has been reached. Once EOF has been reached, this Base64 object becomes useless, and must be thrown away.

#### x

    private int x

Place holder for the 3 bytes we're dealing with for our base64 logic. Bitwise operations store and extract the base64 encoding or decoding from this variable.

### Constructor Detail

#### Base64

    public Base64()

Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.

When encoding the line length is 76, the line separator is CRLF, and the encoding table is STANDARD_ENCODE_TABLE.

When decoding all variants are supported.

#### Base64

    public Base64(boolean urlSafe)

Creates a Base64 codec used for decoding (all modes) and encoding in the given URL-safe mode.

When encoding the line length is 76, the line separator is CRLF, and the encoding table is STANDARD_ENCODE_TABLE.

When decoding all variants are supported.

Parameters:
  `urlSafe` - if `true`, URL-safe encoding is used. In most cases this should be set to `false`.
Since:
  1.4

#### Base64

    public Base64(int lineLength)

Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.

When encoding the line length is given in the constructor, the line separator is CRLF, and the encoding table is STANDARD_ENCODE_TABLE.

Line lengths that aren't multiples of 4 will still essentially end up being multiples of 4 in the encoded data.

When decoding all variants are supported.

Parameters:
  `lineLength` - Each line of encoded data will be at most of the given length (rounded down to nearest multiple of 4). If lineLength <= 0, then the output will not be divided into lines (chunks). Ignored when decoding.
Since:
  1.4

#### Base64

    public Base64(int lineLength,
          byte[] lineSeparator)

Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.

When encoding the line length and line separator are given in the constructor, and the encoding table is STANDARD_ENCODE_TABLE.

Line lengths that aren't multiples of 4 will still essentially end up being multiples of 4 in the encoded data.

When decoding all variants are supported.

Parameters:
  `lineLength` - Each line of encoded data will be at most of the given length (rounded down to nearest multiple of 4). If lineLength <= 0, then the output will not be divided into lines (chunks). Ignored when decoding.
  `lineSeparator` - Each line of encoded data will end with this sequence of bytes.
Throws:
  `java.lang.IllegalArgumentException` - Thrown when the provided lineSeparator included some base64 characters.
Since:
  1.4

#### Base64

    public Base64(int lineLength,
          byte[] lineSeparator,
          boolean urlSafe)

Creates a Base64 codec used for decoding (all modes) and encoding in URL-unsafe mode.

When encoding the line length and line separator are given in the constructor, and the encoding table is STANDARD_ENCODE_TABLE.

Line lengths that aren't multiples of 4 will still essentially end up being multiples of 4 in the encoded data.

When decoding all variants are supported.

Parameters:
  `lineLength` - Each line of encoded data will be at most of the given length (rounded down to nearest multiple of 4). If lineLength <= 0, then the output will not be divided into lines (chunks). Ignored when decoding.
  `lineSeparator` - Each line of encoded data will end with this sequence of bytes.
  `urlSafe` - Instead of emitting '+' and '/' we emit '-' and '_' respectively. urlSafe is only applied to encode operations. Decoding seamlessly handles both modes.
Throws:
  `java.lang.IllegalArgumentException` - The provided lineSeparator included some base64 characters. That's not going to work!
Since:
  1.4

### Method Detail

#### isUrlSafe

    public boolean isUrlSafe()

Returns our current encode mode. True if we're URL-SAFE, false otherwise.

Returns:
  true if we're in URL-SAFE mode, false otherwise.
Since:
  1.4

#### hasData

    boolean hasData()

Returns true if this Base64 object has buffered data for reading.

Returns:
  true if there is Base64 object still available for reading.

#### avail

    int avail()

Returns the amount of buffered data available for reading.

Returns:
  The amount of buffered data available for reading.

#### resizeBuffer

    private void resizeBuffer()

Doubles our buffer.

#### readResults

    int readResults(byte[] b,
                  int bPos,
                  int bAvail)

Extracts buffered data into the provided byte[] array, starting at position bPos, up to a maximum of bAvail bytes. Returns how many bytes were actually extracted.

Parameters:
  `b` - byte[] array to extract the buffered data into.
  `bPos` - position in byte[] array to start extraction at.
  `bAvail` - amount of bytes we're allowed to extract. We may extract fewer (if fewer are available).
Returns:
  The number of bytes successfully extracted into the provided byte[] array.

#### setInitialBuffer

    void setInitialBuffer(byte[] out,
                        int outPos,
                        int outAvail)

Sets the streaming buffer. This is a small optimization where we try to buffer directly to the consumer's output array for one round (if the consumer calls this method first) instead of starting our own buffer.

Parameters:
  `out` - byte[] array to buffer directly to.
  `outPos` - Position to start buffering into.
  `outAvail` - Amount of bytes available for direct buffering.

#### encode

    void encode(byte[] in,
              int inPos,
              int inAvail)

Encodes all of the provided data, starting at inPos, for inAvail bytes. Must be called at least twice: once with the data to encode, and once with inAvail set to "-1" to alert encoder that EOF has been reached, so flush last remaining bytes (if not multiple of 3).

Thanks to "commons" project in ws.apache.org for the bitwise operations, and general approach. http://svn.apache.org/repos/asf/webservices/commons/trunk/modules/util/

Parameters:
  `in` - byte[] array of binary data to base64 encode.
  `inPos` - Position to start reading data from.
  `inAvail` - Amount of bytes available from input for encoding.

#### decode

    void decode(byte[] in,
              int inPos,
              int inAvail)

Decodes all of the provided data, starting at inPos, for inAvail bytes. Should be called at least twice: once with the data to decode, and once with inAvail set to "-1" to alert decoder that EOF has been reached. The "-1" call is not necessary when decoding, but it doesn't hurt, either.

Ignores all non-base64 characters. This is how chunked (e.g. 76 character) data is handled, since CR and LF are silently ignored, but has implications for other bytes, too. This method subscribes to the garbage-in, garbage-out philosophy: it will not check the provided data for validity.

Thanks to "commons" project in ws.apache.org for the bitwise operations, and general approach. http://svn.apache.org/repos/asf/webservices/commons/trunk/modules/util/

Parameters:
  `in` - byte[] array of ascii data to base64 decode.
  `inPos` - Position to start reading data from.
  `inAvail` - Amount of bytes available from input for encoding.

#### isBase64

    public static boolean isBase64(byte octet)

Returns whether or not the `octet` is in the base 64 alphabet.

Parameters:
  `octet` - The value to test
Returns:
  `true` if the value is defined in the the base 64 alphabet, `false` otherwise.
Since:
  1.4

#### isArrayByteBase64

    public static boolean isArrayByteBase64(byte[] arrayOctet)

Tests a given byte array to see if it contains only valid characters within the Base64 alphabet. Currently the method treats whitespace as valid.

Parameters:
  `arrayOctet` - byte array to test
Returns:
  `true` if all bytes are valid characters in the Base64 alphabet or if the byte array is empty; false, otherwise

#### containsBase64Byte

    private static boolean containsBase64Byte(byte[] arrayOctet)

Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.

Parameters:
  `arrayOctet` - byte array to test
Returns:
  `true` if any byte is a valid character in the Base64 alphabet; false herwise

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData)

Encodes binary data using the base64 algorithm but does not chunk the output.

Parameters:
  `binaryData` - binary data to encode
Returns:
  byte[] containing Base64 characters in their UTF-8 representation.

#### encodeBase64String

    public static java.lang.String encodeBase64String(byte[] binaryData)

Encodes binary data using the base64 algorithm into 76 character blocks separated by CRLF.

Parameters:
  `binaryData` - binary data to encode
Returns:
  String containing Base64 characters.
Since:
  1.4

#### encodeBase64URLSafe

    public static byte[] encodeBase64URLSafe(byte[] binaryData)

Encodes binary data using a URL-safe variation of the base64 algorithm but does not chunk the output. The url-safe variation emits - and _ instead of + and / characters.

Parameters:
  `binaryData` - binary data to encode
Returns:
  byte[] containing Base64 characters in their UTF-8 representation.
Since:
  1.4

#### encodeBase64URLSafeString

    public static java.lang.String encodeBase64URLSafeString(byte[] binaryData)

Encodes binary data using a URL-safe variation of the base64 algorithm but does not chunk the output. The url-safe variation emits - and _ instead of + and / characters.

Parameters:
  `binaryData` - binary data to encode
Returns:
  String containing Base64 characters
Since:
  1.4

#### encodeBase64Chunked

    public static byte[] encodeBase64Chunked(byte[] binaryData)

Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks

Parameters:
  `binaryData` - binary data to encode
Returns:
  Base64 characters chunked in 76 character blocks

#### decode

    public java.lang.Object decode(java.lang.Object pObject)

Decodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Decoder interface, and will throw a DecoderException if the supplied object is not of type byte[] or String.

Parameters:
  `pObject` - Object to decode
Returns:
  An object (of type byte[]) containing the binary data which corresponds to the byte[] or String supplied.

#### decode

    public byte[] decode(java.lang.String pArray)

Decodes a String containing containing characters in the Base64 alphabet.

Parameters:
  `pArray` - A String containing Base64 character data
Returns:
  a byte array containing binary data
Since:
  1.4

#### decode

    public byte[] decode(byte[] pArray)

Decodes a byte[] containing containing characters in the Base64 alphabet.

Parameters:
  `pArray` - A byte array containing Base64 character data
Returns:
  a byte array containing binary data

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData,
                      boolean isChunked)

Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.

Parameters:
  `binaryData` - Array containing binary data to encode.
  `isChunked` - if `true` this encoder will chunk the base64 output into 76 character blocks
Returns:
  Base64-encoded data.
Throws:
  `java.lang.IllegalArgumentException` - Thrown when the input array needs an output array bigger than `Integer.MAX_VALUE`

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData,
                      boolean isChunked,
                      boolean urlSafe)

Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.

Parameters:
  `binaryData` - Array containing binary data to encode.
  `isChunked` - if `true` this encoder will chunk the base64 output into 76 character blocks
  `urlSafe` - if `true` this encoder will emit - and _ instead of the usual + and / characters.
Returns:
  Base64-encoded data.
Throws:
  `java.lang.IllegalArgumentException` - Thrown when the input array needs an output array bigger than `Integer.MAX_VALUE`
Since:
  1.4

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData,
                      boolean isChunked,
                      boolean urlSafe,
                      int maxResultSize)

Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.

Parameters:
  `binaryData` - Array containing binary data to encode.
  `isChunked` - if `true` this encoder will chunk the base64 output into 76 character blocks
  `urlSafe` - if `true` this encoder will emit - and _ instead of the usual + and / characters.
  `maxResultSize` - The maximum result size to accept.
Returns:
  Base64-encoded data.
Throws:
  `java.lang.IllegalArgumentException` - Thrown when the input array needs an output array bigger than maxResultSize
Since:
  1.4

#### decodeBase64

    public static byte[] decodeBase64(java.lang.String base64String)

Decodes a Base64 String into octets

Parameters:
  `base64String` - String containing Base64 data
Returns:
  Array containing decoded data.
Since:
  1.4

#### decodeBase64

    public static byte[] decodeBase64(byte[] base64Data)

Decodes Base64 data into octets

Parameters:
  `base64Data` - Byte array containing Base64 data
Returns:
  Array containing decoded data.

#### discardWhitespace

    static byte[] discardWhitespace(byte[] data)

Deprecated. This method is no longer needed
Discards any whitespace from a base-64 encoded block.

Parameters:
  `data` - The base-64 encoded data to discard the whitespace from.
Returns:
  The data, less whitespace (see RFC 2045).

#### isWhiteSpace

    private static boolean isWhiteSpace(byte byteToCheck)

Checks if a byte value is whitespace or not.

Parameters:
  `byteToCheck` - the byte to check
Returns:
  true if byte is whitespace, false otherwise

#### encode

    public java.lang.Object encode(java.lang.Object pObject)

Encodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Encoder interface, and will throw an EncoderException if the supplied object is not of type byte[].

Parameters:
  `pObject` - Object to encode
Returns:
  An object (of type byte[]) containing the base64 encoded data which corresponds to the byte[] supplied.

#### encodeToString

    public java.lang.String encodeToString(byte[] pArray)

Encodes a byte[] containing binary data, into a String containing characters in the Base64 alphabet.

Parameters:
  `pArray` - a byte array containing binary data
Returns:
  A String containing only Base64 character data
Since:
  1.4

#### encode

    public byte[] encode(byte[] pArray)

Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.

Parameters:
  `pArray` - a byte array containing binary data
Returns:
  A byte array containing only Base64 character data

#### getEncodeLength

    private static long getEncodeLength(byte[] pArray,
                       int chunkSize,
                       byte[] chunkSeparator)

Pre-calculates the amount of space needed to base64-encode the supplied array.

Parameters:
  `pArray` - byte[] array which will later be encoded
  `chunkSize` - line-length of the output (<= 0 means no chunking) between each chunkSeparator (e.g. CRLF).
  `chunkSeparator` - the sequence of bytes used to separate chunks of output (e.g. CRLF).
Returns:
  amount of space needed to encoded the supplied array. Returns a long since a max-len array will require Integer.MAX_VALUE + 33%.

#### decodeInteger

    public static java.math.BigInteger decodeInteger(byte[] pArray)

Decodes a byte64-encoded integer according to crypto standards such as W3C's XML-Signature

Parameters:
  `pArray` - a byte array containing base64 character data
Returns:
  A BigInteger
Since:
  1.4

#### encodeInteger

    public static byte[] encodeInteger(java.math.BigInteger bigInt)

Encodes to a byte64-encoded integer according to crypto standards such as W3C's XML-Signature

Parameters:
  `bigInt` - a BigInteger
Returns:
  A byte array containing base64 character data
Throws:
  `java.lang.NullPointerException` - if null is passed in
Since:
  1.4

#### toIntegerBytes

    static byte[] toIntegerBytes(java.math.BigInteger bigInt)

Returns a byte-array representation of a `BigInteger` without sign bit.

Parameters:
  `bigInt` - `BigInteger` to be converted
Returns:
  a byte array representation of the BigInteger parameter

#### reset

    private void reset()

Resets this Base64 object to its initial newly constructed state.